/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Histogram - JGL - 18/06/2012
// 
// Juan Gómez-Luna*, José María González-Linares#, José Ignacio Benavides* and Nicolás Guil#
// *University of Córdoba, #University of Málaga (Spain)
// http://www.ac.uma.es/~vip/
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Histogram of monochrome image by applying R-per-block approach to histogram computation
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//
// histogram_VanHateren_gold.cpp
// This file contains the CPU version of histogram computation monochrome image.
//
// Reference:
// @article {springerlink:10.1007/s00138-012-0443-3,
//   author = {Gómez-Luna, Juan and González-Linares, José and Benavides, José and Guil, Nicolás},
//   affiliation = {Department of Computer Architecture and Electronics, University of Córdoba, Córdoba, Spain},
//   title = {An optimized approach to histogram computation on GPU},
//   journal = {Machine Vision and Applications},
//   publisher = {Springer Berlin / Heidelberg},
//   issn = {0932-8092},
//   keyword = {Computer Science},
//   pages = {1-10},
//   url = {http://dx.doi.org/10.1007/s00138-012-0443-3},
//   note = {10.1007/s00138-012-0443-3},
//}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <math.h>
#include <stdio.h>

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Histogram CPU
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
extern "C" void histo_CPU(unsigned int *histo, unsigned int *data, int size, int BINS){
	for(int i = 0; i < size; i++){
		// Read pixel
		unsigned int d = ((data[i] * BINS) >> 12);

		// Vote in histogram
        histo[d]++;
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
